# coding: utf-8
"""Waylay Query: timeseries queries (v1 protocol) models.

This code was generated from the OpenAPI documentation of 'Waylay Query: timeseries queries (v1 protocol)'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

from typing import List

from pydantic import (
    ConfigDict,
    Field,
    StrictInt,
    StrictStr,
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.alignment import Alignment
from ..models.default_aggregation import DefaultAggregation
from ..models.default_interpolation import DefaultInterpolation
from ..models.grouping_interval import GroupingInterval
from ..models.render import Render
from ..models.series_spec import SeriesSpec
from ..models.time_window_from import TimeWindowFrom
from ..models.time_window_until import TimeWindowUntil
from ..models.window import Window


class QueryOutput(WaylayBaseModel):
    """Query definition for a Waylay analytics query.  See also [api docs](https://docs.waylay.io/#/api/query/?id=data-query-json-representation).."""

    resource: StrictStr | None = Field(
        default=None, description="Default resource for the series in the query."
    )
    metric: StrictStr | None = Field(
        default=None, description="Default metric for the series in the query."
    )
    aggregation: DefaultAggregation | None = None
    interpolation: DefaultInterpolation | None = None
    freq: GroupingInterval | None = None
    var_from: TimeWindowFrom | None = Field(default=None, alias="from")
    until: TimeWindowUntil | None = None
    window: Window | None = None
    periods: StrictInt | None = Field(
        default=None,
        description="The size of the time window in number of `freq` units. One of the [time line](https://docs.waylay.io/#/api/query/?id=time-line-properties) specifiers.",
    )
    align: Alignment | None = None
    data: List[SeriesSpec] | None = Field(
        default=None,
        description="List of series specifications. When not specified, a single default series specification is assumed(`[{}]`, using the default `metric`,`resource`, ... ).",
    )
    render: Render | None = None

    model_config = ConfigDict(
        populate_by_name=True, protected_namespaces=(), extra="allow"
    )
